from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('EndPointRef')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereEndPointRef");
  exportedObject.put("roleName", "WebSphereEndPointRef");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.endpointref.endpointname", objid, "endPointName","EndPointRef");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('EndPointRef');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('EndPointRef')
  if not jsonobject.has("roleProperties"):
    raise Exception("EndPointRef resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "endPointName", roleProperties.optString("websphere.endpointref.endpointname", None));
  print "Creating EndPointRef with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("EndPointRef", parentid, properties);
  Util.popPathElement('EndPointRef');

def update(objid,jsonobject):
  Util.pushPathElement('EndPointRef')
  if not jsonobject.has("roleProperties"):
    raise Exception("EndPointRef resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.endpointref.endpointname", None), "endPointName","EndPointRef");
  if len(atts) != 0:
    print "Modifying EndPointRef with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "EndPointRef configuration up to date.";

  Util.popPathElement('EndPointRef');
